diff -rupN /usr/src/linux-2.4.9/Documentation/Configure.help linux-kgdb/Documentation/Configure.help
--- /usr/src/linux-2.4.9/Documentation/Configure.help	Fri Aug 24 00:12:45 2001
+++ linux-kgdb/Documentation/Configure.help	Sun Aug 26 18:21:41 2001
@@ -2494,6 +2494,13 @@ CONFIG_PCMCIA_SERIAL_CS
   a module, say M here and read Documentation/modules.txt. If unsure,
   say N.
 
+Asynchronous I/O support
+CONFIG_AIO
+  Enables support for Posix Asynchronous I/O Facilities. AIO is supported
+  on all filesystems, including those that have enabled Raw I/O
+  (see "Support raw access to SCSI disk devices" under
+  "SCSI support").
+
 /dev/agpgart (AGP Support) (EXPERIMENTAL)
 CONFIG_AGP
   AGP (Accelerated Graphics Port) is a bus system mainly used to
@@ -11725,6 +11732,12 @@ CONFIG_REISERFS_CHECK
   report, say yes and you might get a useful error message.  Almost
   everyone should say no.
 
+CONFIG_REISERFS_RAW
+  Setting this to yes will enable a set of ioctls that provide raw
+  interface to reiserfs tree, bypassing directories, and automatically
+  removing aged files.  This is an experimental feature disigned for
+  squid cache directories. See Documentation/filesystems/reiserfs_raw.txt
+
 Second extended fs support
 CONFIG_EXT2_FS
   This is the de facto standard Linux file system (method to organize
@@ -15753,6 +15766,39 @@ CONFIG_REMOTE_DEBUG
   several megabytes and requires a machine with more than 16 MB,
   better 32 MB RAM to avoid excessive linking time. This is only
   useful for kernel hackers. If unsure, say N.
+
+KGDB: Remote (serial) kernel debugging with gdb
+CONFIG_X86_REMOTE_DEBUG
+  If you say Y here, it will be possible to remotely debug the x86
+  kernel using gdb. This enlarges your kernel image disk size by
+  several megabytes and requires a machine with more than 16 MB,
+  better 32 MB RAM to avoid excessive linking time. 
+  To use this feature you need to perform some basic setup described
+  briefly in Documentation/i386/gdb-serial.txt.
+  This is only useful for kernel hackers. If unsure, say N.
+
+KGDB: Thread analysis
+CONFIG_KGDB_THREAD
+  With thread analysis enabled, gdb can talk to kgdb stub to list
+  threads and to get stack trace for a thread. This option also enables
+  some code which helps gdb get exact status of thread. Thread analysis
+  adds some overhead to schedule and down functions. You can disable this
+  option if you do not want to compromise on speed.
+
+KGDB: Console messagegs through gdb
+CONFIG_GDB_CONSOLE
+  If you say Y here, console messages will appear through gdb.
+  Other consoles such as tty or ttyS will continue to work as usual.
+  
+KGDB: Enable kernel asserts
+CONFIG_KERNEL_ASSERTS
+  This option enables kernel asserts. A kernel assert is a condition,
+  which if turnes out to be false during an execution path, then kgdb
+  is called. Kernel assertions help in modifying the kernel or writing
+  drivers. Bugs can be traced sooner with kernel asserts because invalid
+  conditions caused by bugs are checked at various places. Kernel asserts
+  add the overhead of checking asserted conditions. You can disable this
+  option if you do not want the overhead.
 
 Magic System Request Key support
 CONFIG_MAGIC_SYSRQ
diff -rupN /usr/src/linux-2.4.9/Makefile linux-kgdb/Makefile
--- /usr/src/linux-2.4.9/Makefile	Fri Aug 24 00:12:45 2001
+++ linux-kgdb/Makefile	Sun Aug 26 18:23:43 2001
@@ -88,7 +88,12 @@ export MODLIB
 CPPFLAGS := -D__KERNEL__ -I$(HPATH)
 
 CFLAGS := $(CPPFLAGS) -Wall -Wstrict-prototypes -Wno-trigraphs -O2 \
-	  -fomit-frame-pointer -fno-strict-aliasing -fno-common
+	  -fno-strict-aliasing -fno-common
+ifeq ($(CONFIG_X86_REMOTE_DEBUG),y)
+CFLAGS += -g
+else
+CFLAGS += -fomit-frame-pointer
+endif
 AFLAGS := -D__ASSEMBLY__ $(CPPFLAGS)
 
 #
diff -rupN /usr/src/linux-2.4.9/arch/i386/Makefile linux-kgdb/arch/i386/Makefile
--- /usr/src/linux-2.4.9/arch/i386/Makefile	Thu Apr 12 22:20:31 2001
+++ linux-kgdb/arch/i386/Makefile	Sun Aug 26 18:21:41 2001
@@ -105,6 +105,11 @@ arch/i386/mm: dummy
 	$(MAKE) linuxsubdirs SUBDIRS=arch/i386/mm
 
 MAKEBOOT = $(MAKE) -C arch/$(ARCH)/boot
+ifeq ($(CONFIG_X86_REMOTE_DEBUG),y)
+CLEANKERNEL = $(MAKE) -C arch/$(ARCH)/kernel kernelclean
+else
+CLEANKERNEL =
+endif
 
 vmlinux: arch/i386/vmlinux.lds
 
@@ -140,6 +145,7 @@ install: vmlinux
 
 archclean:
 	@$(MAKEBOOT) clean
+	@$(CLEANKERNEL)
 
 archmrproper:
 
diff -rupN /usr/src/linux-2.4.9/arch/i386/config.in linux-kgdb/arch/i386/config.in
--- /usr/src/linux-2.4.9/arch/i386/config.in	Sat Jul 21 20:20:34 2001
+++ linux-kgdb/arch/i386/config.in	Sun Aug 26 18:21:41 2001
@@ -185,6 +185,11 @@ endmenu
 mainmenu_option next_comment
 comment 'General setup'
 
+bool 'Asynchronous I/O support' CONFIG_AIO
+if [ "$CONFIG_AIO" = "y" ]; then
+	int  'System-wide limit on outstanding I/Os' CONFIG_AIO_MAX 4096
+fi
+
 bool 'Networking support' CONFIG_NET
 bool 'SGI Visual Workstation support' CONFIG_VISWS
 if [ "$CONFIG_VISWS" = "y" ]; then
@@ -390,4 +395,10 @@ comment 'Kernel hacking'
 
 #bool 'Debug kmalloc/kfree' CONFIG_DEBUG_MALLOC
 bool 'Magic SysRq key' CONFIG_MAGIC_SYSRQ
+bool 'KGDB: Remote (serial) kernel debugging with gdb' CONFIG_X86_REMOTE_DEBUG
+if [ "$CONFIG_X86_REMOTE_DEBUG" != "n" ]; then
+	bool 'KGDB: Thread analysis' CONFIG_KGDB_THREAD
+	bool 'KGDB: Console messages through gdb' CONFIG_GDB_CONSOLE
+	bool 'KGDB: Enable kernel asserts' CONFIG_KERNEL_ASSERTS
+fi
 endmenu
diff -rupN /usr/src/linux-2.4.9/arch/i386/kernel/Makefile linux-kgdb/arch/i386/kernel/Makefile
--- /usr/src/linux-2.4.9/arch/i386/kernel/Makefile	Sat Dec 30 00:35:47 2000
+++ linux-kgdb/arch/i386/kernel/Makefile	Sun Aug 26 18:21:41 2001
@@ -10,7 +10,15 @@
 .S.o:
 	$(CC) $(AFLAGS) -traditional -c $< -o $*.o
 
-all: kernel.o head.o init_task.o
+ifeq ($(CONFIG_X86_REMOTE_DEBUG),y)
+GDBSTART=gdbstart
+GDBCLEAN= -rm -f gdbstart /sbin/gdbstart
+else
+GDBSTART=
+GDBCLEAN=
+endif
+
+all: kernel.o head.o init_task.o $(GDBSTART)
 
 O_TARGET := kernel.o
 
@@ -31,6 +39,7 @@ endif
 endif
 
 obj-$(CONFIG_MCA)	+= mca.o
+obj-$(CONFIG_X86_REMOTE_DEBUG) += gdbstub.o
 obj-$(CONFIG_MTRR)	+= mtrr.o
 obj-$(CONFIG_X86_MSR)	+= msr.o
 obj-$(CONFIG_X86_CPUID)	+= cpuid.o
@@ -40,5 +49,10 @@ obj-$(CONFIG_SMP)	+= smp.o smpboot.o tra
 obj-$(CONFIG_X86_LOCAL_APIC)	+= apic.o
 obj-$(CONFIG_X86_IO_APIC)	+= io_apic.o mpparse.o
 obj-$(CONFIG_X86_VISWS_APIC)	+= visws_apic.o
+
+gdbstart:	gdbstart.o
+		${HOSTCC} -o gdbstart gdbstart.o
+
+kernelclean:	dummy
 
 include $(TOPDIR)/Rules.make
diff -rupN /usr/src/linux-2.4.9/arch/i386/kernel/entry.S linux-kgdb/arch/i386/kernel/entry.S
--- /usr/src/linux-2.4.9/arch/i386/kernel/entry.S	Sat Jul 21 20:19:26 2001
+++ linux-kgdb/arch/i386/kernel/entry.S	Sun Aug 26 18:21:41 2001
@@ -257,7 +257,7 @@ ret_from_exception:
 
 	ALIGN
 reschedule:
-	call SYMBOL_NAME(schedule)    # test
+	call SYMBOL_NAME(user_schedule)    # test
 	jmp ret_from_sys_call
 
 ENTRY(divide_error)
@@ -395,6 +395,31 @@ ENTRY(spurious_interrupt_bug)
 	pushl $ SYMBOL_NAME(do_spurious_interrupt_bug)
 	jmp error_code
 
+#ifdef CONFIG_KGDB_THREAD
+ENTRY(kern_schedule)
+	pushl	%ebp
+	movl	%esp, %ebp
+	pushl	%ss		
+	pushl	%ebp
+	pushfl
+	pushl	%cs
+	pushl	4(%ebp)
+	pushl	%eax		
+	pushl	%es
+	pushl	%ds
+	pushl	%eax
+	pushl	(%ebp)
+	pushl	%edi
+	pushl	%esi
+	pushl	%edx
+	pushl	%ecx
+	pushl	%ebx
+	call	kern_do_schedule
+	movl	%ebp, %esp
+	pop	%ebp
+	ret
+#endif
+
 .data
 ENTRY(sys_call_table)
 	.long SYMBOL_NAME(sys_ni_syscall)	/* 0  -  old "setup()" system call*/
@@ -620,6 +645,39 @@ ENTRY(sys_call_table)
 	.long SYMBOL_NAME(sys_getdents64)	/* 220 */
 	.long SYMBOL_NAME(sys_fcntl64)
 	.long SYMBOL_NAME(sys_ni_syscall)	/* reserved for TUX */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 225 */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 230 */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 235 */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 240 */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 245 */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 250 */
+#if defined(CONFIG_AIO)
+	.long SYMBOL_NAME(sys_aio)		/* 251 */
+#else
+	.long SYMBOL_NAME(sys_ni_syscall)
+#endif
 
 	/*
 	 * NOTE!! This doesn't have to be exact - we just have
Binary files /usr/src/linux-2.4.9/arch/i386/kernel/gdbstart and linux-kgdb/arch/i386/kernel/gdbstart differ
diff -rupN /usr/src/linux-2.4.9/arch/i386/kernel/gdbstart.c linux-kgdb/arch/i386/kernel/gdbstart.c
--- /usr/src/linux-2.4.9/arch/i386/kernel/gdbstart.c	Thu Jan  1 03:00:00 1970
+++ linux-kgdb/arch/i386/kernel/gdbstart.c	Sun Aug 26 18:21:41 2001
@@ -0,0 +1,146 @@
+/*
+ * This program opens a tty file and issues the GDB stub activating
+ * ioctl on it.
+ */
+
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <asm/ioctls.h>
+#include <stdio.h>
+#include <string.h>
+#include <fcntl.h>
+#include <sys/ioctl.h>
+#include <stdlib.h>
+#include <termios.h>
+#include <unistd.h>
+
+char		*tty_name = "/dev/ttyS0" ;	/* COM1 port */
+int		 speed = 9600 ;			/* default speed */
+struct termios	 save_ts ;			/* original term struct */
+
+void print_usage(void)
+{
+    printf("gdbstub [-s speed] [-t tty-dev]\n") ;
+    printf("  defaults:  /dev/ttyS0 with speed unmodified by this program\n");
+
+} /* print_usage */
+
+void tty_err(char *msg)
+{
+    char	buf[100] ;
+
+    strcpy(buf, msg) ;
+    strcat(buf, ": ") ;
+    strcat(buf, tty_name) ;
+    perror(buf) ;
+    exit(1) ;
+
+} /* tty_err */
+
+
+void setup_term(int fd)
+{
+    struct termios	ts ;
+    int			speed_code ;
+
+    if (tcgetattr(fd, &ts) < 0) tty_err("tcgetattr") ;
+
+    save_ts = ts ;
+    switch (speed)
+    {
+    case 4800:
+	speed_code = B4800 ;
+	break ;
+    case 9600:
+	speed_code = B9600 ;
+	break ;
+    case 19200:
+	speed_code = B19200 ;
+	break ;
+    case 38400:
+	speed_code = B38400 ;
+	break ;
+    case 57600:
+	speed_code = B57600 ;
+	break ;
+    case 115200:
+	speed_code = B115200 ;
+	break ;
+    case 230400:
+	speed_code = B230400 ;
+	break ;
+    default:
+	printf("Invalid speed: %d\n", speed) ;
+	exit(1) ;
+    }
+
+    ts.c_cflag = CS8 | CREAD | CLOCAL ;
+    if (cfsetospeed(&ts, speed_code) < 0) tty_err("cfsetospeed") ;
+    if (cfsetispeed(&ts, speed_code) < 0) tty_err("cfsetispeed") ;
+
+    if (tcsetattr(fd, TCSANOW, &ts) < 0) tty_err("tcsetattr") ;
+
+} /* setup_term */
+
+void main(int argc, char **argv)
+{
+    int		opt ;
+    int		fil ;
+    int		rslt ;
+
+    while ((opt = getopt(argc, argv, "hs:t:")) > 0)
+    {
+	switch (opt)
+	{
+	case 's':
+	    speed = atol(optarg) ;
+	    break ;
+	case 't':
+	    tty_name = optarg ;
+	    break ;
+	case ':':
+	    printf("Invalid option\n") ;
+	    break ;
+	case '?':
+	case 'h':
+	default:
+	    print_usage() ;
+	    return ;
+	}
+    }
+
+    fil = open(tty_name, O_RDWR) ;
+    if (fil < 0)
+    {
+	perror(tty_name) ;
+	return ;
+    }
+
+
+    setup_term(fil) ;
+
+    /*
+     * When we issue this ioctl, control will not return until
+     * the debugger running on the remote host machine says "go".
+     */
+    printf("\nAbout to activate GDB stub in the kernel on %s\n", tty_name) ;
+    printf("Hit CR to continue, kill program to abort -- ") ;
+    getchar() ;
+    sync() ;
+    rslt = ioctl(fil, TIOCGDB, 0) ;
+    if (rslt < 0)
+    {
+	perror("TIOCGDB ioctl") ;
+	return ;
+    }
+
+    printf("\nGDB stub successfully activated\n") ;
+
+    for (;;)
+    {
+	pause() ;
+    }
+
+    if (tcsetattr(fil, TCSANOW, &save_ts) < 0) tty_err("tcsetattr") ;
+
+} /* main */
